<?php

/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package gamers_studio
 */

function gamers_studio_customize_css() {
    $primary_color_or_gradient = get_theme_mod( 'primary_color_or_gradient', 'linear-gradient(90.09deg, #F213FF 0%, #07D0ED 99.23%)' );
    ?>
    <style type="text/css">
        :root {
            --primary-color: <?php echo esc_html( $primary_color_or_gradient ); ?>;
        }
    </style>
    <?php
}
add_action( 'wp_head', 'gamers_studio_customize_css' );

function add_custom_script_in_footer() {
    if ( get_theme_mod( 'gamers_studio_enable_sticky_header', false ) ) {
        ?>
        <script>
            jQuery(document).ready(function($) {
                $(window).on('scroll', function() {
                    var scroll = $(window).scrollTop();
                    if (scroll > 0) {
                        $('.navigation-part.hello').addClass('is-sticky');
                    } else {
                        $('.navigation-part.hello').removeClass('is-sticky');
                    }
                });
            });
        </script>
        <?php
    }
}
add_action( 'wp_footer', 'add_custom_script_in_footer' );


function gamers_studio_enqueue_selected_fonts() {
    $gamers_studio_fonts_url = gamers_studio_get_fonts_url();
    if (!empty($gamers_studio_fonts_url)) {
        wp_enqueue_style('gamers-studio-google-fonts', $gamers_studio_fonts_url, array(), null);
    }
}
add_action('wp_enqueue_scripts', 'gamers_studio_enqueue_selected_fonts');

function gamers_studio_layout_customizer_css() {
    $gamers_studio_margin = get_theme_mod('gamers_studio_layout_width_margin', 50);
    ?>
    <style type="text/css">
        body.site-boxed--layout #page  {
            margin: 0 <?php echo esc_attr($gamers_studio_margin); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_layout_customizer_css');

function gamers_studio_blog_layout_customizer_css() {
    // Retrieve the blog layout option
    $gamers_studio_blog_layout_option = get_theme_mod('gamers_studio_blog_layout_option_setting', 'Left');

    // Initialize custom CSS variable
    $gamers_studio_custom_css = '';

    // Generate custom CSS based on the layout option
    if ($gamers_studio_blog_layout_option === 'Default') {
        $gamers_studio_custom_css .= '.mag-post-detail { text-align: center; }';
    } elseif ($gamers_studio_blog_layout_option === 'Left') {
        $gamers_studio_custom_css .= '.mag-post-detail { text-align: left; }';
    } elseif ($gamers_studio_blog_layout_option === 'Right') {
        $gamers_studio_custom_css .= '.mag-post-detail { text-align: right; }';
    }

    // Output the combined CSS
    ?>
    <style type="text/css">
        <?php echo wp_kses($gamers_studio_custom_css, array( 'style' => array(), 'text-align' => array() )); ?>
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_blog_layout_customizer_css');

function gamers_studio_sidebar_width_customizer_css() {
    $gamers_studio_sidebar_width = get_theme_mod('gamers_studio_sidebar_width', '30');
    ?>
    <style type="text/css">
        .right-sidebar .asterthemes-wrapper .asterthemes-page {
            grid-template-columns: auto <?php echo esc_attr($gamers_studio_sidebar_width); ?>%;
        }
        .left-sidebar .asterthemes-wrapper .asterthemes-page {
            grid-template-columns: <?php echo esc_attr($gamers_studio_sidebar_width); ?>% auto;
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_sidebar_width_customizer_css');

if ( ! function_exists( 'gamers_studio_get_page_title' ) ) {
    function gamers_studio_get_page_title() {
        $gamers_studio_title = '';

        if (is_404()) {
            $gamers_studio_title = esc_html__('Page Not Found', 'gamers-studio');
        } elseif (is_search()) {
            $gamers_studio_title = esc_html__('Search Results for: ', 'gamers-studio') . esc_html(get_search_query());
        } elseif (is_home() && !is_front_page()) {
            $gamers_studio_title = esc_html__('Blogs', 'gamers-studio');
        } elseif (function_exists('is_shop') && is_shop()) {
            $gamers_studio_title = esc_html__('Shop', 'gamers-studio');
        } elseif (is_page()) {
            $gamers_studio_title = get_the_title();
        } elseif (is_single()) {
            $gamers_studio_title = get_the_title();
        } elseif (is_archive()) {
            $gamers_studio_title = get_the_archive_title();
        } else {
            $gamers_studio_title = get_the_archive_title();
        }

        return apply_filters('gamers_studio_page_title', $gamers_studio_title);
    }
}

if ( ! function_exists( 'gamers_studio_has_page_header' ) ) {
    function gamers_studio_has_page_header() {
        // Default to true (display header)
        $gamers_studio_return = true;

        // Custom conditions for disabling the header
        if ('hide-all-devices' === get_theme_mod('gamers_studio_page_header_visibility', 'all-devices')) {
            $gamers_studio_return = false;
        }

        // Apply filters and return
        return apply_filters('gamers_studio_display_page_header', $gamers_studio_return);
    }
}

if ( ! function_exists( 'gamers_studio_page_header_style' ) ) {
    function gamers_studio_page_header_style() {
        $gamers_studio_style = get_theme_mod('gamers_studio_page_header_style', 'default');
        return apply_filters('gamers_studio_page_header_style', $gamers_studio_style);
    }
}

function gamers_studio_page_title_customizer_css() {
    $gamers_studio_layout_option = get_theme_mod('gamers_studio_page_header_layout', 'left');
    ?>
    <style type="text/css">
        .asterthemes-wrapper.page-header-inner {
            <?php if ($gamers_studio_layout_option === 'flex') : ?>
                display: flex;
                justify-content: space-between;
                align-items: center;
            <?php else : ?>
                text-align: <?php echo esc_attr($gamers_studio_layout_option); ?>;
            <?php endif; ?>
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_page_title_customizer_css');

function gamers_studio_pagetitle_height_css() {
    $gamers_studio_height = get_theme_mod('gamers_studio_pagetitle_height', 50);
    ?>
    <style type="text/css">
        header.page-header {
            padding: <?php echo esc_attr($gamers_studio_height); ?>px 0;
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_pagetitle_height_css');

function gamers_studio_customize_scss() {
    // Retrieve the two colors from the customizer settings.
    $gamers_studio_color1 = get_theme_mod('gamers_studio_gradient_color1', '#F213FF'); // Default start color
    $gamers_studio_color2 = get_theme_mod('gamers_studio_gradient_color2', '#07D0ED'); // Default end color

    // Generate the gradient.
    $gamers_studio_gradient = "linear-gradient(90.09deg, $gamers_studio_color1 0%, $gamers_studio_color2 99.23%)";
    ?>
    <style type="text/css">
        :root {
            --primary-color: <?php echo esc_html($gamers_studio_color1); ?>; /* Fallback color (color1) */
            --primary-gradient: <?php echo esc_html($gamers_studio_gradient); ?>; /* Dynamically generated gradient */
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_customize_scss');

function gamers_studio_site_logo_width() {
    $gamers_studio_site_logo_width = get_theme_mod('gamers_studio_site_logo_width', 200);
    ?>
    <style type="text/css">
        .site-logo img {
            max-width: <?php echo esc_attr($gamers_studio_site_logo_width); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_site_logo_width');

function gamers_studio_menu_font_size_css() {
    $gamers_studio_menu_font_size = get_theme_mod('gamers_studio_menu_font_size', 16);
    ?>
    <style type="text/css">
        .main-navigation a {
            font-size: <?php echo esc_attr($gamers_studio_menu_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_menu_font_size_css');

//Menu Font Weight
function gamers_studio_menu_font_weight_css() {
	$gamers_studio_font_weight = get_theme_mod( 'gamers_studio_menu_font_weight', 500);

	$gamers_studio_custom_css = "
		.main-navigation a {
		    font-weight: {$gamers_studio_font_weight};
		}
	";

	wp_add_inline_style( 'gamers-studio-style', $gamers_studio_custom_css );
}
add_action( 'wp_enqueue_scripts', 'gamers_studio_menu_font_weight_css' );

// Featured Image Dimension
function gamers_studio_custom_featured_image_css() {
    $gamers_studio_dimension = get_theme_mod('gamers_studio_blog_post_featured_image_dimension', 'default');
    $gamers_studio_width = get_theme_mod('gamers_studio_blog_post_featured_image_custom_width', '');
    $gamers_studio_height = get_theme_mod('gamers_studio_blog_post_featured_image_custom_height', '');
    
    if ($gamers_studio_dimension === 'custom' && $gamers_studio_width && $gamers_studio_height) {
        $gamers_studio_custom_css = "body:not(.single-post) .mag-post-single .mag-post-img img { width: {$gamers_studio_width}px !important; height: {$gamers_studio_height}px !important; }";
        wp_add_inline_style('gamers-studio-style', $gamers_studio_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'gamers_studio_custom_featured_image_css');

// Featured Image Border Radius
function gamers_studio_featured_image_border_radius_css() {
    $gamers_studio_featured_image_border_radius = get_theme_mod('gamers_studio_featured_image_border_radius', 10);
    ?>
    <style type="text/css">  
        .mag-post-single img {
            border-radius: <?php echo esc_attr($gamers_studio_featured_image_border_radius); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_featured_image_border_radius_css');

function gamers_studio_sidebar_widget_font_size_css() {
    $gamers_studio_sidebar_widget_font_size = get_theme_mod('gamers_studio_sidebar_widget_font_size', 24);
    ?>
    <style type="text/css">
        h2.wp-block-heading,aside#secondary .widgettitle,aside#secondary .widget-title {
            font-size: <?php echo esc_attr($gamers_studio_sidebar_widget_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_sidebar_widget_font_size_css');

// Woocommerce Related Products Settings
function gamers_studio_related_product_css() {
    $gamers_studio_related_product_show_hide = get_theme_mod('gamers_studio_related_product_show_hide', true);

    if ( $gamers_studio_related_product_show_hide != true) {
        ?>
        <style type="text/css">
            .related.products {
                display: none;
            }
        </style>
        <?php
    }
}
add_action('wp_head', 'gamers_studio_related_product_css');

// Woocommerce Product Sale Position 
function gamers_studio_product_sale_position_customizer_css() {
    $gamers_studio_layout_option = get_theme_mod('gamers_studio_product_sale_position', 'left');
    ?>
    <style type="text/css">
        .woocommerce ul.products li.product .onsale {
            <?php if ($gamers_studio_layout_option === 'left') : ?>
                right: auto;
                left: 0px;
            <?php else : ?>
                left: auto;
                right: 0px;
            <?php endif; ?>
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_product_sale_position_customizer_css');  

//Footer Social Icon Alignment
function gamers_studio_footer_icons_alignment_css() {
    $gamers_studio_footer_social_align = get_theme_mod( 'gamers_studio_footer_social_align', 'center' );   
    ?>
    <style type="text/css">
        .socialicons {
            text-align: <?php echo esc_attr( $gamers_studio_footer_social_align ); ?> 
        }

        /* Mobile Specific */
        @media screen and (max-width: 575px) {
            .socialicons {
                text-align: center;
            }
        }
    </style>
    <?php
}
add_action( 'wp_head', 'gamers_studio_footer_icons_alignment_css' );

//Copyright Alignment
function gamers_studio_footer_copyright_alignment_css() {
    $gamers_studio_footer_bottom_align = get_theme_mod( 'gamers_studio_footer_bottom_align', 'center' );   
    ?>
    <style type="text/css">
        .site-footer .site-footer-bottom .site-footer-bottom-wrapper {
            justify-content: <?php echo esc_attr( $gamers_studio_footer_bottom_align ); ?> 
        }

        /* Mobile Specific */
        @media screen and (max-width: 575px) {
            .site-footer .site-footer-bottom .site-footer-bottom-wrapper {
                justify-content: center;
                text-align:center;
            }
        }
    </style>
    <?php
}
add_action( 'wp_head', 'gamers_studio_footer_copyright_alignment_css' );

//Copyright Font Size
function gamers_studio_copyright_font_size_css() {
    $gamers_studio_copyright_font_size = get_theme_mod('gamers_studio_copyright_font_size', 16);
    ?>
    <style type="text/css">
        .site-footer-bottom .site-info span {
            font-size: <?php echo esc_attr($gamers_studio_copyright_font_size); ?>px;
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_copyright_font_size_css');

// Preloader Background Color Setting
function gamers_studio_preloader_background_colors_css() {
    $gamers_studio_preloader_background_color_setting = get_theme_mod('gamers_studio_preloader_background_color_setting', '');
        // Only output CSS if a color is set
        if (empty($gamers_studio_preloader_background_color_setting)) {
            return;
        }
    ?>
    <style type="text/css">
        #loader {
            background-color: <?php echo esc_attr($gamers_studio_preloader_background_color_setting); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_preloader_background_colors_css');

// Preloader Background Image Setting
function gamers_studio_preloader_background_image_css() {
    $gamers_studio_preloader_background_image_setting = get_theme_mod('gamers_studio_preloader_background_image_setting', '');
        // Only output CSS if the background image is set
        if (empty($gamers_studio_preloader_background_image_setting)) {
            return;
        }
    ?>
    <style type="text/css">
        #loader {
            background-image: url('<?php echo esc_url($gamers_studio_preloader_background_image_setting); ?>');
            background-size: cover;
            background-repeat: no-repeat;
            background-position: center;
        }
    </style>
    <?php
}
add_action('wp_head', 'gamers_studio_preloader_background_image_css');

//Footer Heading Alignment
function gamers_studio_footer_heading_alignment_css() {
    $gamers_studio_footer_header_align = get_theme_mod( 'gamers_studio_footer_header_align', 'left' );   
    ?>
    <style type="text/css">
        .site-footer h4, footer#colophon h2.wp-block-heading, footer#colophon .widgettitle, footer#colophon .widget-title {
            text-align: <?php echo esc_attr( $gamers_studio_footer_header_align ); ?> 
        }
    </style>
    <?php
}
add_action( 'wp_head', 'gamers_studio_footer_heading_alignment_css' );

//First Capital Letter
function gamers_studio_show_first_caps() {
	$gamers_studio_first_caps = get_theme_mod('gamers_studio_show_first_caps', false);
	$gamers_studio_css = '';
	if ( $gamers_studio_first_caps ) {
	$gamers_studio_css .= '
		.mag-post-single .mag-post-detail .mag-post-excerpt p:first-of-type::first-letter {
		    font-size: 55px;
			font-weight: 600;
			margin-right: 6px;
			line-height: 1;
			display: inline-block;
			vertical-align: baseline;
		}';
	} else {
		$gamers_studio_css .= '
		.mag-post-single .mag-post-detail .mag-post-excerpt p:first-of-type::first-letter {
			display: none;
		}';
	}
	wp_add_inline_style( 'gamers-studio-style', $gamers_studio_css );
}
add_action( 'wp_enqueue_scripts', 'gamers_studio_show_first_caps' );

// Banner Button Color
function gamers_studio_banner_button_color_css() {

    $btn_color = get_theme_mod('gamers_studio_banner_btn_color');
    $btn_bg_color = get_theme_mod('gamers_studio_banner_btn_bg_color');

    $custom_css = '';

    if ( !empty($btn_color) ) {
        $custom_css .= "
        .banner-slider-btn a.asterthemes-button{
            color: {$btn_color} !important;
        }";
    }

    if ( !empty($btn_bg_color) ) {
        $custom_css .= "
        .banner-slider-btn a.asterthemes-button{
            background: {$btn_bg_color} !important;
        }";
    }

    wp_add_inline_style('gamers-studio-style', $custom_css);
}
add_action('wp_enqueue_scripts','gamers_studio_banner_button_color_css');